import 'dart:io';

import 'package:enx_flutter_plugin/enx_player_widget.dart';
import 'package:enx_uikit_flutter/controller/enx_controller.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';

Widget landscapeMode(BuildContext context, EnxController enxController) {
  return Row(
    children: [
      enxController.activeTalkerList.isNotEmpty
          ? Card(
              child: SizedBox(
              height: MediaQuery.of(context).size.height - 30.h,
              width: enxController.activeTalkerList.length > 1
                  ? MediaQuery.of(context).size.width / 1.4
                  : MediaQuery.of(context).size.width - 10.h,
              child: Expanded(
                child: EnxPlayerWidget(
                  enxController.activeTalkerList[0].streamId!,
                  local: false,
                  height: 200.h.toInt(),
                  width: 100.w.toInt(),
                  zMediaOverlay: true,
                ),
              ),
            ))
          : Text(
              'Wait for others to join',
              style: TextStyle(color: Colors.white, fontSize: 16.sp),
            ),
      enxController.activeTalkerList.length > 1
          ? Expanded(
              child: ListView.builder(
                shrinkWrap: true,
                scrollDirection: Axis.vertical,
                itemCount: enxController.activeTalkerList.length,
                itemBuilder: (BuildContext context, int index) {
                  return index > 0
                      ? Padding(
                          padding: EdgeInsets.zero,
                          child: Card(
                            child: SizedBox(
                                height: MediaQuery.of(context).size.height / 2 -
                                    5.h,
                                width: MediaQuery.of(context).size.width,
                                child: Platform.isAndroid
                                    ? EnxPlayerWidget(
                                        enxController
                                            .activeTalkerList[index].streamId!,
                                        local: false,
                                        height: 150.h.toInt(),
                                        width: 100.w.toInt(),
                                      )
                                    : AspectRatio(
                                        aspectRatio: 3 / 2,
                                        child: EnxPlayerWidget(
                                          enxController.activeTalkerList[index]
                                              .streamId!,
                                          local: false,
                                          height: 150.h.toInt(),
                                          width: 100.w.toInt(),
                                        ))),
                          ),
                        )
                      : Container();
                },
              ),
            )
          : Container(),
    ],
  );
}

Widget portraitView(BuildContext context, EnxController enxController) {
  return Column(
    children: [
      enxController.activeTalkerList.isNotEmpty
          ? Card(
              child: SizedBox(
              height: enxController.activeTalkerList.length > 1
                  ? MediaQuery.of(context).size.height - 188.h
                  : MediaQuery.of(context).size.height - 35.h,
              width: MediaQuery.of(context).size.width,
              child: Expanded(
                child: EnxPlayerWidget(
                  enxController.activeTalkerList[0].streamId!,
                  local: false,
                  height: 200.h.toInt(),
                  width: 100.w.toInt(),
                ),
              ),
            ))
          : Text(
              'Wait for others to join',
              style: TextStyle(color: Colors.white, fontSize: 16.sp),
            ),
      enxController.activeTalkerList.length > 1
          ? Container(
              height: 150.h,
              width: MediaQuery.of(context).size.width,
              alignment: Alignment.bottomCenter,
              child: ListView.builder(
                shrinkWrap: true,
                scrollDirection: Axis.horizontal,
                itemCount: enxController.activeTalkerList.length,
                itemBuilder: (BuildContext context, int index) {
                  return index > 0
                      ? Padding(
                          key: Key('$index'),
                          padding: EdgeInsets.zero,
                          child: Card(
                            child: SizedBox(
                                width: MediaQuery.of(context).size.width / 2,
                                child: Platform.isAndroid
                                    ? EnxPlayerWidget(
                                        enxController
                                            .activeTalkerList[index].streamId!,
                                        local: false,
                                        height: 150.h.toInt(),
                                        width: 100.w.toInt(),
                                      )
                                    : AspectRatio(
                                        aspectRatio: 3 / 2,
                                        child: EnxPlayerWidget(
                                          enxController.activeTalkerList[index]
                                              .streamId!,
                                          local: false,
                                          height: 150.h.toInt(),
                                          width: 100.w.toInt(),
                                        ))),
                          ),
                        )
                      : Container();
                },
              ),
            )
          : Container(),
    ],
  );
}

Widget viewFloat(BuildContext context, EnxController enxController) {
  return MediaQuery.of(context).orientation == Orientation.portrait
      ? portraitView(context, enxController)
      : landscapeMode(context, enxController);
}
